/* Copyright (C) 2009, 2010, 2011, 2012 Keith Crane

This file is part DFILE Tools.

DFILE Tools is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or (at
your option) any later version.

DFILE Tools is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with DFILE Tools; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>. */

#define WHERE_UNIXERR	-1
#define WHERE_NOERR	0
#define WHERE_SYNTAX	1
#define WHERE_UNKNVAR	2
#define WHERE_INVLDNBR	3
#define WHERE_REGEX	4
#define WHERE_HASHFAIL	5

typedef enum { Where_result_unknown = 0, Where_result_false, Where_result_true } where_result_t;

extern const char *Where_err_msg[];
extern const size_t Where_err_msg_cnt;

int where_compile_file( void **, char *, size_t, const char *, dfile_t * );
int where_condition( where_result_t *, char *, size_t, void * );
const char *where_error( int );
int where_compile_sexpr( void **, char *, size_t, void *, dfile_t * );
